;========================================================
; Atomic Muncher
; By Erik557
;
; Description: A muncher that acts like a falling spike
; but that explodes in ground contact.
;
; Uses first extra bit: YES
; When set, it'll rise instead of falling.
;========================================================

Tilemap:
       db $EE,$EC

;=================================
; INIT and MAIN Wrappers
;=================================

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR FallingSpike
       PLB
print "INIT ",pc
       RTL

;========================
; Main routine
;========================

MainReturn:
       RTS
FallingSpike:
       LDA $C2,x
       BNE .Jump
       LDA $14AE
       BNE +
.Jump
       JMP .Normal
+      PHA
       %GetDrawInfo()
       PLA
       DEC
       BNE .SpawnCoin
       LDA $D8,x
       STA $98
       LDA $14D4,x
       STA $99
       LDA $E4,x
       STA $9A
       LDA $14E0,x
       STA $9B

       LDA $1594,x
       BEQ MainReturn
       LDA $98
       AND #$F0
       STA $06
       LDA $9A
       LSR #4
       ORA $06
       PHA
       LDA $5B
       AND #$01
       BEQ .horzLevel
       PLA
       LDX $99
       CLC
       ADC.l $00BA80,x
       STA $05
       LDA.l $00BABC,x
       ADC $9B
       STA $06
       BRA .vertLevel
.horzLevel
       PLA
       LDX $9B
       CLC
       ADC.l $00BA60,x
       STA $05
       LDA.l $00BA9C,x
       ADC $99
       STA $06
.vertLevel
       LDA #$7E
       STA $07
       LDX $15E9

       INC $07
       LDA [$05]
       BNE .Kill
       DEC $07
       LDA [$05]
       CMP #$2B
       BNE .Kill
       LDA #$02
       STA $9C
       JSL $00BEB0
       STZ $1594,x
       RTS

.Kill
       STZ $14C8,x
       RTS
.SpawnCoin
       LDA $1594,x
       BNE .Return
       LDA $D8,x
       STA $98
       LDA $14D4,x
       STA $99
       LDA $E4,x
       STA $9A
       LDA $14E0,x
       STA $9B
       LDA #$06
       STA $9C
       JSL $00BEB0
       INC $1594,x
       RTS

.Locked
       LDA $1540,x
       BEQ FallingSpike_Return
       JMP Fall_Explode2
.Normal
       JSR Graphics
       LDA $9D
       BNE .Locked
       LDY $15EA,x
       LDA $163E,x
       BEQ .DontShake
       LSR #2
       AND #$01
       CLC
       ADC $0300,y
       STA $0300,y
.DontShake
       LDY #$00
       %SubOffScreen()
       LDA $7FAB10,x
       AND #$04
       BNE +
       JSL $01802A
       BRA .Cont
+      JSL $01801A
       JSL $019138
.Cont
       LDA $C2,x
       BNE Fall
       STZ $AA,x
       %SubHorzPos()
       LDA $0E
       CLC
       ADC #$40
       CMP #$80
       BCS FallingSpike_Return
       INC $C2,x
       LDA #$20
       STA $163E,x
       LDA #$04
       STA $190F,x
FallingSpike_Return:
       RTS

Fall:
       LDA $163E,x
       BNE .Freeze
       LDA $1490
       BNE +
       JSL $01A7DC
+      LDA $1540,x
       BEQ +
       CMP #$01
       BNE .Explode2
       STZ $14C8,x
       RTS
+      LDA $7FAB10,x
       AND #$04
       LSR #2
       TAY
       LDA $1588,x
       AND compare,y
       BEQ +
       LDA #$1F
       STA $1540,x
.Explode
       LDA #$08
       STA $1DF9
.Explode2
       PEA.w ($02)|(FallingSpike>>16<<8)
       PLB
       JSL $028086
       PLB
       STZ $AA,x
+      LDA $7FAB10,x
       AND #$04
       BEQ .Return
       LDA $AA,x
       SEC
       SBC #$03
       CMP #$D0
       BCS .Store
       LDA #$D0
.Store
       STA $AA,x
.Return
       RTS

.Freeze
       STZ $AA,x
       RTS

compare:
       db $24,$88

;========================
; Graphics routine
;========================

Graphics:
       %GetDrawInfo()
       LDA $7FAB10,x
       AND #$04
       LSR #2
       STA $02
       REP #$20
       LDA $00
       STA $0300,y
       SEP #$20
       LDA $0301,y
       DEC 
       STA $0301,y
       LDA $C2,x
       BEQ +
       LDA $14
       AND #$03
       TAX
       LDA palettes,x
       BRA .no
+      ORA #$07
.no
       ORA $64
       LDX $02
       ORA props,x
       STA $0303,y
       LDX $15E9
       LDX #$00
       LDA $14
       CLC
       ADC #$04
       LSR #3
       AND #$01
       TAX
       LDA Tilemap,x
       STA $0302,y
       LDX $15E9
       LDY #$02
       TDC
       JSL $01B7B3
       RTS

palettes:
       db $03,$05,$07,$09
props:
       db $80,$00
